/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *  ---
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
 */
#ident "$Id: strrchr.c,v 1.1 1997/07/31 22:47:37 steve Exp $"

# include  <string.h>

/*
 * This is a default, portable and unoptimized implementation of the
 * ISO C strrchr function.
 */
char*strrchr(const char*s1, int c)
{
      register char*rp = 0;
      for ( ; *s1 ;  s1 += 1)
	    if (*s1 == c) rp = (char*)s1;

      if (c == 0) rp = s1;
      return rp;
}

/*
 * $Log: strrchr.c,v $
 * Revision 1.1  1997/07/31 22:47:37  steve
 *  Add more ISO-C functions.
 *
 */

