
#
# Copyright (c) 1995 Picture Elements Inc.
#	Stephen Williams
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
.ident "$Id: uCR_switch-m68k_coff.s,v 1.2 1996/10/28 03:46:47 steve Exp $"
#
# $Log: uCR_switch-m68k_coff.s,v $
# Revision 1.2  1996/10/28 03:46:47  steve
#  License notice.
#
# Revision 1.1  1996/05/27 22:50:04  steve
#  implement thread_create and thread_switch for the i960,
#  rename some __foo symbols to uCR_foo for neatness.
#
# Revision 1.1  1996/05/24 01:46:45  steve
#  Initial port to i960_cyclone
#  Seperate some files in the library to seperate files
#  for making smaller binaries, use uCR_ prefix for private
#  symbols, move assembly files around for compile-time
#  portability, change __start to ucr_start and give it
#  new behavior, and simplify the ucr_assert implementation.
#
#


# Save the registers in the self thread cookie, and get new
# registers from the new thread structure. The switch includes
# the stack pointer, and so also includes the stack itself.

	.global uCR_switch
uCR_switch:
	movel	%a1,-(%sp)
	movel	8(%sp),%a0	| pointer to new thread
	movel	12(%sp),%a1	| pointer to self

			| Save the registers including the stack
			| pointer so they can be restored.
	moveml	#0xffff,(%a1)
	movew	%sr,64(%a1)

			| Now restore the registers from the thread
			| I am going to, including the stack
			| pointer.
	movew	64(%a0),%sr
	moveml	(%a0),#0xffff
	movel	(%sp)+,%a1
	rts

