#ifndef __ucr_param_H
#define __ucr_param_H
/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: param.h,v 1.2 1996/10/28 03:45:28 steve Exp $"
/*
 * $Log: param.h,v $
 * Revision 1.2  1996/10/28 03:45:28  steve
 *  License notice.
 *
 * Revision 1.1  1996/08/02 00:19:43  steve
 *  Move the param.h header file.
 *
 * Revision 1.1  1996/05/29 04:36:30  steve
 *  Support interrupts in the i960_cyclone world, and in the
 *  process reorganize interrupt code for portability.
 *
 */

/*
 * Use the m68k autovector interrupts only, and allow the numbers to
 * be shared, requiring more then on ISR per interrupt.
 */
# define MAX_EXCEPTION 8
# define MAX_ISR_PER_EXCEPTION 4

#endif
