#
# Copyright (c) 1996 Picture Elements Inc.
#	Stephen Williams
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
.ident "$Id: I960RP_dma.s,v 1.4 1997/08/19 05:43:37 steve Exp $"
#
# $Log: I960RP_dma.s,v $
# Revision 1.4  1997/08/19 05:43:37  steve
#  Potential speedup of packet dma.
#
# Revision 1.3  1997/02/12 05:57:50  steve
#  Support all three i960RP DMA channels.
#
# Revision 1.2  1996/10/28 03:45:39  steve
#  License notice.
#
# Revision 1.1  1996/10/04 23:34:26  steve
#  Add a BUS driver for the ISE board.
#
#

# This source allocates space for dma cells, that is carefully aligned.
# the I960RP has extreme alignment constraints for DMA cells, so I must
# resort to assembly code.

	.file "I960RP_dma.s"
	.sect .bss
	.global $dma_cell

	.balign	32
$dma_cell:
	.rept 6
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.long	0
	.endr
